#!/usr/bin/perl

use strict;

my $header=
"@			IN SOA	ns.hren.tebe.ru. root.hren.tebe.ru. (
				0000000000	; serial
				3600		; refresh (1 hour)
				900		; retry (15 minutes)
				2419200		; expire (4 weeks)
				3600		; minimum (1 hour)
				)

			IN NS	ns.gremlin.ru.
			IN NS	ns2.stabilis.ru.
			IN NS	ns6.grumbler.org.
			IN NS	ns.fidonet.net.
";

my $line; my $node; my %hosts; my $host; my $port;

while ($line = <>)
{
 $line =~ s/[\x0a\x0d\x1a]//g;

#     

 next unless $line =~ /INA:/;
 next if $line =~ /^(Hold|Down|Pvt),/;

 if ($line =~ /^(Hub)?,(\d+),.*,INA:([0-9a-zA-Z\.\-]+)(,.*)?/)
 {
  $node = $2;
  $host = $3;
 }
 elsif ($line =~ /^Host,.*,INA:([0-9a-zA-Z\.\-]+)(,.*)?/)
 {
  $node = 0;
  $host = $1;
 }

 if ($line =~ /.*,IBN:(\d+)(,.*)?/)
 {
  $host .= ":$1";
 }

 $hosts{"$node"} = $host;
}

my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime();
my $serial=sprintf("%04u%02u%02u%02u",$year+1900,$mon,$mday,$hour);
$header =~ s/0000000000/$serial/g;
print "$header\n";

for $node (sort {$a <=> $b} keys(%hosts))
{
 $host = $hosts{"$node"};
 $port = "";
 if ($host =~ /\:/)
 {
  ($host, $port) = split /\:/, $host;
 }
 if ($host =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/)
 {
  print "f$node\t\t\tIN A\t\t$host\n";
 }
# elsif ($host =~ /^[a-z0-9](\-?[a-z0-9])?(\.[a-z0-9](\-?[a-z0-9])?)+$/)
 elsif ($host =~ /^[a-z0-9\-\.]+/i)
 {
  print "f$node\t\t\tIN CNAME\t$host.\n";
 }
 if ($port =~ /\d+/)
 {
  print "_binkp._tcp.f$node\tIN SRV\t\t0 0 $port f$node\n";
 }
}
